__author__ = 'Alex'
import scipy.cluster.hierarchy as hc

class SingleLinkage():
    """ Wrapper Class for compatibility with sklearn

    """
    def __init__(self, n_clusters):
        self.n_clusters = n_clusters
        self.labels = None

    def fit(self, dataset):
        """ calculate the hierarchie and return cluster labels for self.n_clusters

        :param dataset: dataset to be clustered
        :return: cluster labels
        """
        hierarchy = hc.linkage(dataset, method='single', metric='euclidean')
        self.labels = hc.fcluster(hierarchy, self.n_clusters, criterion='maxclust')

    def predict(self, dataset):
        """ return calculated labels. in case run wasn't used before run fit first

        :param dataset: dataset do be clustered
        :return: cluster labels
        """
        if self.labels is None:
            self.fit(dataset)
        return self.labels