__author__ = 'Alex'
import numpy as np

def aggregation():
    """ loads the Aggregation Dataset from Aggregation.txt
    Source: http://cs.joensuu.fi/sipu/datasets/

    :return: dataset, true labels
    """
    dataset = np.loadtxt(open("../Datasets/Aggregation.txt", "rb"))
    return dataset[:, 0:len(dataset[1])-1], dataset[:, -1]


def standard():
    """ loads the Aggregation Dataset from Aggregation.txt
    Source: http://cs.joensuu.fi/sipu/datasets/

    :return: dataset, true labels
    """
    dataset = np.loadtxt(open("../Datasets/standard.txt", "rb"))
    return dataset[:, 0:len(dataset[1])-1], dataset[:, -1]

def compound():
    """ loads the Aggregation Dataset from Aggregation.txt
    Source: http://cs.joensuu.fi/sipu/datasets/

    :return: dataset, true labels
    """
    dataset = np.loadtxt(open("../Datasets/Compound.txt", "rb"))
    return dataset[:, 0:len(dataset[1])-1], dataset[:, -1]

def trex():
    """ loads the Aggregation Dataset from Aggregation.txt
    Source: http://cs.joensuu.fi/sipu/datasets/

    :return: dataset, true labels
    """
    dataset = np.loadtxt(open("../Datasets/GoodTRex.csv", "rb"), delimiter=";", skiprows=1)
    return dataset[:, 0:len(dataset[1])-1], dataset[:, -1]

def d31(size=None):
    """ loads the Aggregation Dataset from Aggregation.txt
    Source: http://cs.joensuu.fi/sipu/datasets/

    :return: dataset, true labels
    """
    dataset = np.loadtxt(open("../Datasets/D31.txt", "rb"))
    if size is not None:
        B=np.random.randint(len(dataset), size=size)
        dataset = dataset[B, :]

    return dataset[:, 0:len(dataset[1])-1], dataset[:, -1]


def r15():
    """ loads the Aggregation Dataset from Aggregation.txt
    Source: http://cs.joensuu.fi/sipu/datasets/

    :return: dataset, true labels
    """
    dataset = np.loadtxt(open("../Datasets/R15.txt", "rb"))
    return dataset[:, 0:len(dataset[1])-1], dataset[:, -1]

def flame():
    """ loads the Flame Dataset from flame.txt
    Source: http://cs.joensuu.fi/sipu/datasets/

    :return: dataset, true labels
    """
    dataset = np.loadtxt(open("../Datasets/flame.txt", "rb"))
    return dataset[:, 0:len(dataset[1])-1], dataset[:, -1]


def jain():
    """ loads the Jain Dataset from jain.txt
    Source: http://cs.joensuu.fi/sipu/datasets/

    :return: dataset, true labels
    """
    dataset = np.loadtxt(open("../Datasets/jain.txt", "rb"))
    return dataset[:, 0:len(dataset[1])-1], dataset[:, -1]


def pathbased():
    """ loads the Pathbased Dataset from pathbased.txt
    Source: http://cs.joensuu.fi/sipu/datasets/

    :return: dataset, true labels
    """
    dataset = np.loadtxt(open("../Datasets/pathbased.txt", "rb"))
    return dataset[:, 0:len(dataset[1])-1], dataset[:, -1]


def spiral():
    """ loads the Spiral Dataset from spiral.txt
    Source: http://cs.joensuu.fi/sipu/datasets/

    :return: dataset, true labels
    """
    dataset = np.loadtxt(open("../Datasets/spiral.txt", "rb"))
    return dataset[:, 0:len(dataset[1])-1], dataset[:, -1]


def t48k(size=None):
    """ loads the t48k Dataset from t48k.txt
    Source: http://cs.joensuu.fi/sipu/datasets/

    :return: dataset
    """
    dataset = np.loadtxt(open("../Datasets/t48k.txt", "rb"))
    if size is not None:
        B=np.random.randint(len(dataset), size=size)
        dataset = dataset[B, :]
    return dataset

def birch1():
    """ loads the birch1 Dataset from birch1.txt
    Source: http://cs.joensuu.fi/sipu/datasets/

    :return: dataset
    """
    dataset = np.loadtxt(open("../Datasets/birch1.txt", "rb"))
    return dataset[:, 0:len(dataset[1])-1]

def birch2():
    """ loads the birch2 Dataset from birch2.txt
    Source: http://cs.joensuu.fi/sipu/datasets/

    :return: dataset
    """
    dataset = np.loadtxt(open("../Datasets/birch2.txt", "rb"))
    return dataset[:, 0:len(dataset[1])-1]

def birch3():
    """ loads the birch3 Dataset from birch3.txt
    Source: http://cs.joensuu.fi/sipu/datasets/

    :return: dataset
    """
    dataset = np.loadtxt(open("../Datasets/birch3.txt", "rb"))
    return dataset[:, 0:len(dataset[1])-1]


if __name__ == "__main__":
    print("aggregation", aggregation())
    #print("D31", d31())
    #print("r15", r15())
    #print("compound", compound())